#include "../include/FileUtils.h"
#include <filesystem>
#include <fstream>
#include <iostream>
#include <vector>

bool FileUtils::fileExists(const char *path){
    return filesystem::exists(path);
}

vector<unsigned char> FileUtils::open_image(const string& path) {
    std::ifstream file(path, std::ios::binary);
    if (!file) {
        std::cerr << "Error opening file: " << path << std::endl;
        return {}; // Return an empty vector on error
    }

    std::vector<unsigned char> data;
    char c;

    while (file.get(c)) {
        data.push_back(static_cast<unsigned char>(c));
    }

    file.close();
    return data;
}

vector<string> FileUtils::get_image_list(const string& path) {
    vector<string> images;
    const std::string ext(".avif");
    for (auto &p : filesystem::recursive_directory_iterator(path))
    {
        if (p.path().extension() == ext) {
            images.push_back(p.path().stem().string());
        }
    }

    return images;
}